<?php
/*
	Plugin Name: Simple Bible Linker Russian
	Plugin URI: http://www.bible.com.ua
	Description: This plugin is designed to help people referring to Russian Bible. Once activated, it will find all texts that look like references to Biblical texts and replace them with link to actualy biblical chapter and verses. Russian only.
	Version: 1.0
	Author: Igor Ivashchenko
	Author URI: http://www.bible.com.ua


    Copyright 2009  Igor Ivashchenko  (email : igor@online.ua)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

	
	function SearchBibleLinks($content) {

		$TextString=$content;
		$VerseDivider=":";
		$TargetSelf="1";
		
		//Include array of possible abbreviations of Book Names vs. their url part (i.e. id of the book)
		//You can enhance this function to provide an array for every language or Bible translation version
		
				$BookByName = array(
					'Быт' => '1',
					'Бт'  => '1',
					'Бытие' => '1',
					'Книга Бытие' => '1',
					'Исх' => '2',
					'Исход' => '2',
					'Книга Исход' => '2',
					'Лев' => '3',
					'Левит' => '3',
					'Книга Левит' => '3', 
					'Числа' => '4',
					'Книга Чисел' => '4',
					'Чис' => '4',
					'Чс' => '4',
					'Вт' => '5',
					'Втор' => '5',
					'Книга Второзаконие' => '5',
					'Второзаконие' => '5',
					'Ис Нав' => '6',
                    'Нав' => '6',
					'Иисус Навин' => '6',
					'Книга Иисуса Навина' => '6',
					 'Книга Судей'=> '7',
					'Суд'=> '7',
					'Руфь'=> '8',
					'Руф'=> '8',
					'Книга Руфь'=> '8',
					'1 Цар' => '9',
					'1Цар' => '9',
                    '1 Царств' => '9',
                    '1Царств' => '9',
					'Первая книга Царств' => '9',
					'2 Цар' => '10',
					'2Цар' => '10',
                    '2 Царств' => '10',
                    '2Царств' => '10',
					'Вторая книга Царств' => '10',
					'3 Цар' => '11',
					'3Цар' => '11', 
                    '3 Царств' => '11',             
                    '3Царств' => '11',                                 
					'Третья книга Царств' => '11',
					'4 Цар' => '12',
					'4Цар' => '12',
                    '4Царств' => '12',
                    '4 Царств' => '12',
					'Четвертая книга Царств' => '12',
					'1 Пар' => '13',
					'1Пар' => '13',
					'1 Паралипоменон' => '13',
                    '1Паралипоменон' => '13',
                    'Первый Паралипоменон' => '13',
					'Первая книга Паралипоменон' => '13',
					'2 Пар' => '14',
					'2Пар' => '14',
                    '2 Паралипоменон' => '14',
                    '2Паралипоменон' => '14',
					'Второй Паралипоменон' => '14',
					'Вторая книга Паралипоменон' => '14',
					'Ездра' => '15',
					'Книга Ездры' => '15',
					'Ездр' => '15',
					'Ез' => '15',
					'Езд' => '15',
					'Неемия' => '16',
					'Книга Неемии' => '16',
					'Неем' => '16', 
					'Есфирь' => '17',
					'Книга Есфирь' => '17',
					'Есф' => '17',
					'Ес' => '17',
					'Иов' => '18',
					'Ив' => '18',
					'Книга Иова' => '18',
					'Пс' => '19',
					'Псал' => '19',
					'Псалтырь' => '19', 
					'Псалом' => '19',
					'Книга Псалтырь' => '19',
					'Пр' => '20',
					'Прит' => '20',
					'Притчи' => '20',
					'Книга Притч' => '20',
					'Книга Притчей Соломона' => '20',
					'Екклесиаст' => '21',
					'Книга Екклесиаста' => '21',
					'Екк' => '21',
					'Ек' => '21',
					'Екл' => '21',
					'Еккл' => '21',
					'Песнь Песней' => '22',
					'Книга Песнь Песней' => '22',
					'Пес Пес' => '22',
					'Песн' => '22',
					'Пес' => '22',
					'Ис' => '23',
					'Исайя' => '23',
                    'Исаия' => '23',
                    'Исаии' => '23',
                    'Исайи' => '23',
					'Книга Исайя' => '23',
					'Книга пророка Исайя' => '23',
					'Иер' => '24',
					'Ир' => '24',
					'Иеремии' => '24',
					'Иерем' => '24',
					'Книга Иеремии' => '24',
					'Книга пророка Иеремии' => '24',
					'Плач' => '25',
					'Пл' => '25',
					'Плач Иеремии' => '25',
					'Книга Плач Иеремии' => '25',
					'Из' => '26',
					'Иез' => '26',
					'Иезекииль' => '26',
					'Иезекииля' => '26',
					'Книга Иезекииля' => '26',
					'Книга пророка Иезекииля' => '26',
					'Дн' => '27',
					'Дан' => '27',
					'Даниила' => '27',
					'Книга Даниила' => '27',
					'Книга пророка Даниила' => '27',
					'Ос' => '28',
					'Осия' => '28',
					'Осии' => '28',
					'Книга Осии' => '28',
					'Книга пророка Осии' => '28',
					'Иоиль' => '29',
					'Книга Иоиль' => '29',
					'Книга Иоиля' => '29',
					'Книга пророка Иоиль' => '29',
					'Ам' => '30',
					'Амос' => '30',
					'Амоса' => '30',
					'Книга Амоса'=> '30',
					 'Книга пророка Амоса' => '30',
					'Адвий' => '31',
					'Книга Авдия' => '31',
					'Книга пророка Авдия' => '31',
					'Ав' => '31',
					'Авд' => '31',
					'Иона' => '32',
					'Ионы' => '32',
					'Ион' => '32',
					'Книга Ионы' => '32',
					'Книга пророка Ионы' => '32',
					'Мх' => '33',
					'Мих' => '33',
					'Михей' => '33',
					'Михея' => '33',
					'Книга Михея' => '33',
					'Книга пророка Михея' => '33',
					'Наум' => '34',
					'Наума' => '34',
					'Книга Наума' => '34',
					'Книга пророка Наума' => '34',
					'Ав' => '35',
					'Авв' => '35',
					'Аввакум' => '35',
					'Аввакума' => '35',
					'Книга Аввакума' => '35',
					'Книга пророка Аввакума' => '35',
					'Софония' => '36',
					'Книга Софонии' => '36',
					'Соф' => '36',
					'Сф' => '36',
					'Книга пророка Софонии' => '36',
					'Аг' => '37', 
					'Агг' => '37', 
					'Аггей' => '37', 
					'Аггея' => '37',
					'Книга Аггея' => '37',
					'Книга пророка Аггея' => '37',
					'Зах' => '38',
					'Захар' => '38', 
					'Захарии' => '38',
					'Захария' => '38',	
					'Книга Захарии' => '38',
					'Книга пророка Захарии' => '38',
					'Мал' => '39',
					'Мл' => '39',
					'Малахия' => '39', 
					'Малахии' => '39',
					'Книга Малахии' => '39',
					'Книга пророка Малахии' => '39',
					'Мф' => '40',
					'Мат' => '40',
					'Матф' => '40',
					'Матфея' => '40',
                    'Матфей' => '40',
					'Евангелие по Матфею' => '40',
					'Евангелие от Матфея' => '40',
					'Мк' => '41',
					 'Мар' => '41',
					'Марка' => '41',
                    'Марк' => '41',
					'Евангелия от Марка' => '41',
					'Евангелие по Марку' => '41',
					'Лк' => '42',
					'Лук' => '42',
					'Луки' => '42',
					'Евангелие по Луке' => '42',
					'Евангелие от Луки' => '42',
					'Деян' => '44',
					'Деяния' => '44',
					'Книга Деяния' => '44',
					'Деяния апостолов' => '44', 
					'Иак' => '59',
					'Ик' => '59',
					'Иакова' => '59',
					'Послание Иакова' => '59',
					'1 Пет' => '60',
					'1Пет' => '60',
					'Первое послание Петра' => '60', 
					'2 Пет' => '61',
					'2Пет' => '61', 
					'Второе послание Петра' => '61',
					 '1 Ин' => '62',
                     '1 Иоанна' => '62',
                     '1Иоан' => '62',
                     '1Иоанна' => '62',
					'1Ин' => '62',
					'Первое Послание Иоанна' => '62',
		            '2 Ин' => '63',
                    '2Ин' => '63',
                   '2 Иоан' => '63',
                    '2Иоан' => '63',
                   '2 Иоанна' => '63',
                    '2Иоанна' => '63',
                    'Второе Послание Иоанна' => '63',
                    '3 Ин' => '64',
                    '3Ин' => '64',
                    '3 Иоанна' => '64',
                    '3Иоанна' => '64',
                    '3 Иоан' => '64',
                    '3Иоан' => '64',
                    'Третье Послание Иоанна' => '64',
					'Иуд' => '65',
					'Ид' => '65',
					'Иуды' => '65',
					'Послание Иуды' => '65',
					'Рим' => '45',
                    'Послание к Римлянам' => '45',
					'Римлянам' => '45',
					'Послание к римлянам' => '45', 
					'1Кор' => '46',
					'1 Кор' => '46',
					'Первое послание к Коринфянам' => '46',
                    '1 Коринфянам' => '46',
					'2Кор' => '47',
					'2 Кор' => '47',
					'Второе послание к коринфянам' => '47',
                    '2 Коринфянам' => '47',
					'Гал' => '48',
					'Галатам' => '48',
					'Послание к галатам' => '48',
					'Еф' => '49',
					'Эф' => '49',
					'Ефес' => '49',
					'Эфес' => '49',	
					'Послание к эфесянам' => '49',
					'Флп' => '50',
					'Фил' => '50',
					'Послание к филиппийцам' => '50',
                    'Послание к Филиппийцам' => '50',
                    'Филиппийцам' => '50',
					'Кол' => '51',
					'Кл' => '51',
					'Послание к колоссянам' => '51',
					'1Фес' => '52',
					'1 Фес' => '52',
					'Первое послание к фессалоникийцам' => '52',
					'2Фес' => '53',
					'2 Фес' => '53',
					'Второе послание к фессалоникийцам' => '53',
					'1Тим' => '54',
					'1 Тим' => '54',
                    '1Тимофею' => '54',
                    '1 Тимофею' => '54',
                    '1 Тимофей' => '54',
					'Первое послание к Тимофею' => '54',
					'2 Тим' => '55',
                    '2 Тимофей' => '55',
                    '2 Тимофею' => '55',
					'Второе послание к Тимофею' => '55',
					'Тит' => '56',
					'Титу' => '56',
					'Послание к Титу' => '56',
					'Флм' => '57',
					'Филимону' => '57',
					'Послание к Филимону' => '57',
					'Евр' => '58',
					'Евреям' => '58',
					'Послание к Евреям' => '58', 
					'Откр' => '66',
					'Отк' => '66',
					'Откровение' => '66',
					'Откровение Иоанна Богослова' => '66',
					'Ин' => '43',
					'Иоанн' => '43',
                    'Иоан' => '43',
					'Евангелие от Иоанна' => '43',
					'Евангелие по Иоанну' => '43',
					);
		
		//URL of your Bible section at your site
		
		$BibleURL="http://www.bible.com.ua/bible/r/";
		
		// Optional parameter. Symbol that separates chapter from the verse. 
		// If not set, verses should be separated by semicolon
		// In some languages this maybe coma or a dot. 
		
		if ($VerseDivider=="" || $VerseDivider==FALSE)
							$VerseDivider=":";
		
		// Optional parameter. Link target. If not set - opens in _blank.
		// Usually we want to open the link in new window, but sometimes it is need to open it in the same window we are in.
		
		if ($TargetSelf=="1"):
							$TargetSelf="_self";
							else:
							$TargetSelf="_blank";
		endif;
										
		// Magic Moment. Now, go through the array of BookNames and search for each on in the string
		
		foreach ($BookByName as $BookByName_temp=>$BookByName_temp_value) {
			
					$TextString=preg_replace("!($BookByName_temp(\?| |.|. |.\r\n|\r\n)([0-9]{1,5})".$VerseDivider."([0-9]{1,10})(\?|\-[0-9]{1,3}|,[0-9]{1,3}|,[0-9]{1,3}|\b)|$BookByName_temp(\?| |.|. |.\r\n|\r\n)([0-9]{1,6}))!s","<a href=\"$BibleURL$BookByName_temp_value/\\7\\3#\\4\" target=\"$TargetSelf\">\\1</a>",$TextString);
	
			
		}
		
		//Clean doubled inside links. Inner ones to be removed.
		
		$TextString=preg_replace("!((<a href=([^>]*>))([^<]*)(<a href=([^>]*>))([^<]*)(<\/a>)(<\/a>))!s"," \\2\\4\\7\\9",$TextString);

		$content=$TextString;
		
		return $content;
	
	}

add_filter('the_content', 'SearchBibleLinks');

?>
